USE [COWS]
GO
/****** Object:  StoredProcedure [dbo].[InsertBPMRedesignToCOWSRedesign]    Script Date: 1/18/2022 10:27:59 AM ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
-- =============================================================
-- Author:		<Sarah Sandoval>
-- Create date: <02/25/2021>
-- Description:	<Systematic process to create BPM Redesign>
-- Updated By:	<Sarah Sandoval>
-- Update Date: <04/15/2021>
-- Description:	<Added updated for Pending-SDE/Pending-NTE>
-- Updated By:	<Sarah Sandoval>
-- Update Date: <06/22/2021>
-- Description:	<Added Contact Details>
-- =============================================================
ALTER PROCEDURE [dbo].[InsertBPMRedesignToCOWSRedesign]
	
AS
BEGIN
	BEGIN TRY
		SET NOCOUNT ON;

		DECLARE @MNSRedesignToCOWSRedesign TABLE (
			ID					INT IDENTITY(1,1)
			,MNS_DD_NBR			VARCHAR(20)
			,H1_ID				VARCHAR(9)
			,H1_CUST_NME		VARCHAR(1000)
			,CMNT_TXT			VARCHAR(MAX)
			,REDSGN_TYPE_CD		VARCHAR(100)
			,SD_WAN_FLG_CD		VARCHAR(20)
			,CISCO_SMART_FLG_CD	VARCHAR(20)
			,SMART_ACCT_DOMN_ID	VARCHAR(100)
			,VRTL_ACCT_ID		VARCHAR(100)
			,REDSGN_CAT_CD		VARCHAR(100)
			,STUS_NME			VARCHAR(100)
			,DEV_NME			VARCHAR(50)
			,TEST_UPLD_URL_TXT	VARCHAR(2000)
			,CREATE_DT			DATETIME
			,PR_DD_NBR			VARCHAR(20)
			,CREATE_BY_NME		VARCHAR(100)
			,EMAIL_ADR			VARCHAR(500)
			,H6_ID				VARCHAR(9)
			,NTE_USER_ID		VARCHAR(100)
			,PM_USER_ID			VARCHAR(100)
			,CUST_PDL_ADR		VARCHAR(500))

		DECLARE @CTR INT = 1, @CNT INT = 0
		DECLARE @sql NVARCHAR(MAX) = ''
		SET @sql = 'SELECT * FROM OPENQUERY(nrmbpm,''SELECT * FROM BPMF_OWNER.V_Bpmf_Cows_Mns_Rdsgn_Act_Evnt WHERE STUS_NME = ''''Created'''' '')'

		--PRINT @sql
		INSERT INTO @MNSRedesignToCOWSRedesign
		EXEC sp_executeSQL @sql
		SELECT @CNT = COUNT(1) FROM @MNSRedesignToCOWSRedesign
		--SELECT STUS_NME, PR_DD_NBR, * FROM @MNSRedesignToCOWSRedesign
		DELETE @MNSRedesignToCOWSRedesign FROM @MNSRedesignToCOWSRedesign mr INNER JOIN dbo.REDSGN r WITH (NOLOCK) ON mr.PR_DD_NBR = r.BPM_REDSGN_NBR OR mr.PR_DD_NBR = r.REDSGN_NBR
		--SELECT STUS_NME, PR_DD_NBR, * FROM @MNSRedesignToCOWSRedesign

		DECLARE @PR_DD_NBR VARCHAR(20) = '', @EMAIL_ADR VARCHAR(500) = '', @CUST_PDL VARCHAR(500) = '',
				@NTE_USR VARCHAR(500) = '', @PM_USR VARCHAR(500) = '', @CMNT_TXT VARCHAR(MAX) = '', @BPM_DATA_TXT VARCHAR(MAX) = ''

		WHILE (@CTR <= @CNT)
		BEGIN
			SELECT @PR_DD_NBR = PR_DD_NBR, @CMNT_TXT = CMNT_TXT, @EMAIL_ADR = EMAIL_ADR, 
					@NTE_USR = NTE_USER_ID, @PM_USR = PM_USER_ID, @CUST_PDL = CUST_PDL_ADR
			FROM @MNSRedesignToCOWSRedesign WHERE ID = @CTR
				AND PR_DD_NBR NOT IN (SELECT BPM_REDSGN_NBR FROM dbo.REDSGN WITH (NOLOCK) WHERE BPM_REDSGN_NBR = @PR_DD_NBR)

			IF ((ISNULL(@PR_DD_NBR,'') != ''))
			BEGIN
				-- Insert Redesign
				INSERT INTO dbo.REDSGN (REDSGN_NBR
											,H1_CD
											,CUST_NME
											,REDSGN_TYPE_ID
											,IS_SDWAN
											,CISC_SMRT_LIC_CD
											,SMRT_ACCNT_DMN
											,VRTL_ACCNT
											,REDSGN_CAT_ID
											,STUS_ID
											,ADDL_DOC_TXT
											,CUST_EMAIL_ADR
											,NTE_ASSIGNED
											,PM_ASSIGNED
											,BPM_REDSGN_NBR
											,ENTIRE_NW_CKD_ID
											,CRETD_BY_CD
											,CRETD_DT
											,SUBMIT_DT
											,SLA_DT
											,EXPRTN_DT)
				SELECT TOP 1 (SELECT TOP 1 CASE  LEN(REDSGN_NBR) -  LEN(SUBSTRING(REDSGN_NBR,2,LEN(REDSGN_NBR)) + 1)
						WHEN 1 THEN 'R' + CONVERT(VARCHAR,SUBSTRING(REDSGN_NBR,2,LEN(REDSGN_NBR)) + 1)
						WHEN 2 THEN 'R0' + CONVERT(VARCHAR,SUBSTRING(REDSGN_NBR,2,LEN(REDSGN_NBR)) + 1)
						WHEN 3 THEN 'R00' + CONVERT(VARCHAR,SUBSTRING(REDSGN_NBR,2,LEN(REDSGN_NBR)) + 1)
						WHEN 4 THEN 'R000' + CONVERT(VARCHAR,SUBSTRING(REDSGN_NBR,2,LEN(REDSGN_NBR)) + 1)
						WHEN 5 THEN 'R0000' + CONVERT(VARCHAR,SUBSTRING(REDSGN_NBR,2,LEN(REDSGN_NBR)) + 1)
						WHEN 6 THEN 'R00000' + CONVERT(VARCHAR,SUBSTRING(REDSGN_NBR,2,LEN(REDSGN_NBR)) + 1)
						WHEN 7 THEN 'R000000' + CONVERT(VARCHAR,SUBSTRING(REDSGN_NBR,2,LEN(REDSGN_NBR)) + 1)
						WHEN 8 THEN 'R0000000' + CONVERT(VARCHAR,SUBSTRING(REDSGN_NBR,2,LEN(REDSGN_NBR)) + 1)
						WHEN 9 THEN 'R00000000' + CONVERT(VARCHAR,SUBSTRING(REDSGN_NBR,2,LEN(REDSGN_NBR)) + 1)
						WHEN 10 THEN 'R000000000' + CONVERT(VARCHAR,SUBSTRING(REDSGN_NBR,2,LEN(REDSGN_NBR)) + 1)
					END
					FROM REDSGN WITH (NOLOCK) ORDER BY REDSGN_ID DESC) AS REDSGN_NBR
					,H1_ID
					,H1_CUST_NME
					,(SELECT REDSGN_TYPE_ID FROM LK_REDSGN_TYPE
						WHERE REDSGN_TYPE_NME = REDSGN_TYPE_CD
						AND REDSGN_CAT_ID = CASE REDSGN_CAT_CD
							WHEN 'Voice' THEN 1
							WHEN 'Data' THEN 2
							ELSE 3
					END) AS REDSGN_TYPE_ID
					,CASE SD_WAN_FLG_CD
						WHEN 'Yes' THEN 1
						ELSE 0
					END
					,CASE CISCO_SMART_FLG_CD
						WHEN 'Yes' THEN 1
						ELSE 0
					END
					,CASE CISCO_SMART_FLG_CD
						WHEN 'Yes' THEN SMART_ACCT_DOMN_ID
						ELSE NULL
					END
					,CASE CISCO_SMART_FLG_CD
						WHEN 'Yes' THEN VRTL_ACCT_ID
						ELSE NULL
					END
					,CASE REDSGN_CAT_CD
						WHEN 'Voice' THEN 1
						WHEN 'Data' THEN 2
						ELSE 3
					END
					,221 --Submitted
					,TEST_UPLD_URL_TXT
					,CUST_PDL_ADR
					,NTE_USER_ID
					,PM_USER_ID
					,PR_DD_NBR
					,0
					,ISNULL((SELECT USER_ID FROM dbo.LK_USER WITH (NOLOCK) WHERE USER_ADID = CREATE_BY_NME), 1) --Use System if null
					,GETDATE() -- Creation Date
					,GETDATE() -- Submitted Date
					,dbo.CalculateEndBusinessDate(GETDATE(),6) -- SLA Date (5 Business days) - added 1 daya for the function includes the start date
					,DATEADD(DAY, 181, GETDATE()) -- Expiration Date (181 days)
				FROM @MNSRedesignToCOWSRedesign
				WHERE ID = @CTR AND PR_DD_NBR NOT IN (SELECT BPM_REDSGN_NBR FROM dbo.REDSGN WITH (NOLOCK) WHERE BPM_REDSGN_NBR = @PR_DD_NBR)

				DECLARE @RedesignID INT = 0
				SET @RedesignID = @@IDENTITY

				-- Insert Redesign Devices Info
				INSERT INTO dbo.REDSGN_DEVICES_INFO (REDSGN_ID, SEQ_NBR, DEV_NME, H6_CUST_ID, NTE_CHRG_CD, REC_STUS_ID, CRETD_BY_CD, CRETD_DT)
				SELECT @RedesignID, 0, DEV_NME, H6_ID, 0, 1, 1, GETDATE()
				FROM @MNSRedesignToCOWSRedesign
				WHERE PR_DD_NBR = @PR_DD_NBR AND DEV_NME IS NOT NULL

				-- Insert Redesign Notes for CMNT_TXT
				IF (ISNULL(@CMNT_TXT,'') != '')
					BEGIN
						INSERT INTO dbo.REDSGN_NOTES (REDSGN_ID,REDSGN_NTE_TYPE_ID,NOTES,CRETD_BY_CD,CRETD_DT)
						SELECT @RedesignID, 2, @CMNT_TXT, 1, GETDATE()
					END

				-- Insert Redesign Notes for Submitted Status
				INSERT INTO dbo.REDSGN_NOTES (REDSGN_ID,REDSGN_NTE_TYPE_ID,NOTES,CRETD_BY_CD,CRETD_DT)
				SELECT @RedesignID, 1, 'Status changed to Submitted', 1, GETDATE()
			
				-- Insert Systematic Redesign Notes for MNS_DD_NBR
				INSERT INTO dbo.REDSGN_NOTES (REDSGN_ID,REDSGN_NTE_TYPE_ID,NOTES,CRETD_BY_CD,CRETD_DT)
				SELECT @RedesignID, 4, 'Systematically created Redesign using BPM Redesign # ' + ISNULL(@PR_DD_NBR,''), 1, GETDATE()

				-- Insert Email for REDSGN_EMAIL_NTFCTN
				IF (ISNULL(@EMAIL_ADR,'') != '')
					BEGIN
						DECLARE @EMAIL_NTFCTN TABLE (EMAIL_ADR	VARCHAR(500))
						INSERT INTO @EMAIL_NTFCTN
						SELECT * FROM web.ParseCommaSeparatedStrings(@EMAIL_ADR)
						INSERT INTO dbo.REDSGN_EMAIL_NTFCTN (REDSGN_ID, USER_IDNTFCTN_EMAIL, REC_STUS_ID, CRETD_USER_ID, CRETD_DT)
						SELECT @RedesignID, EMAIL_ADR, 1, 1, GETDATE() FROM @EMAIL_NTFCTN
					END

				-- Insert NTE into Contact Details
				IF (ISNULL(@NTE_USR,'') != '')
					BEGIN
						INSERT INTO dbo.CNTCT_DETL (OBJ_ID, OBJ_TYP_CD, HIER_LVL_CD, HIER_ID, ROLE_ID, 
							EMAIL_ADR, PHN_NBR, AUTO_RFRSH_CD, REC_STUS_ID, CREAT_DT, CREAT_BY_USER_ID)
						SELECT r.REDSGN_ID, 'R', 'H1', r.H1_CD, 81, nu.EMAIL_ADR, nu.PHN_NBR,
								0, 1, GETDATE(), ISNULL(cu.USER_ID, 1)
						FROM dbo.REDSGN r WITH (NOLOCK)
						INNER JOIN @MNSRedesignToCOWSRedesign b ON r.BPM_REDSGN_NBR = b.PR_DD_NBR
						LEFT JOIN dbo.LK_USER nu WITH (NOLOCK) ON r.NTE_ASSIGNED = nu.USER_ADID
						LEFT JOIN dbo.LK_USER cu WITH (NOLOCK) ON b.CREATE_BY_NME = cu.USER_ADID
						WHERE r.REDSGN_ID = @RedesignID
					END
				
				-- Insert PM into Contact Details
				IF (ISNULL(@PM_USR,'') != '')
					BEGIN
						INSERT INTO dbo.CNTCT_DETL (OBJ_ID, OBJ_TYP_CD, HIER_LVL_CD, HIER_ID, ROLE_ID, 
							EMAIL_ADR, PHN_NBR, AUTO_RFRSH_CD, REC_STUS_ID, CREAT_DT, CREAT_BY_USER_ID)
						SELECT r.REDSGN_ID, 'R', 'H1', r.H1_CD, 122, nu.EMAIL_ADR, nu.PHN_NBR,
								0, 1, GETDATE(), ISNULL(cu.USER_ID, 1)
						FROM dbo.REDSGN r WITH (NOLOCK)
						INNER JOIN @MNSRedesignToCOWSRedesign b ON r.BPM_REDSGN_NBR = b.PR_DD_NBR
						LEFT JOIN dbo.LK_USER nu WITH (NOLOCK) ON r.NTE_ASSIGNED = nu.USER_ADID
						LEFT JOIN dbo.LK_USER cu WITH (NOLOCK) ON b.CREATE_BY_NME = cu.USER_ADID
						WHERE r.REDSGN_ID = @RedesignID
					END
				
				-- Insert Email for Submitted Status
				IF EXISTS (SELECT 'x' FROM @MNSRedesignToCOWSRedesign WHERE ID = @CTR 
					AND (ISNULL(EMAIL_ADR,'') != '' OR ISNULL(NTE_USER_ID,'') != '' OR ISNULL(PM_USER_ID,'') != '' OR ISNULL(CUST_PDL_ADR,'') != ''))
					BEGIN
						EXEC dbo.InsertRedesignEmailData_V2 @RedesignID, 221, 0
					END

				-- Insert BPM_REDSN_TXN
				SET @BPM_DATA_TXT = (SELECT TOP 1
					(SELECT PR_DD_NBR
							,REDSGN_NBR AS MNS_DD_NBR
							,H1_ID
							,CMNT_TXT
							,'Submitted' AS STUS_NME
							,r.CRETD_DT AS CREATE_DT
							,r.SUBMIT_DT AS SUBMIT_DT
							,r.SLA_DT AS SLA_DT
							,r.EXPRTN_DT AS EXPIRY_DT
						FROM @MNSRedesignToCOWSRedesign mr
						JOIN dbo.REDSGN r WITH (NOLOCK) ON mr.PR_DD_NBR = r.BPM_REDSGN_NBR
						WHERE PR_DD_NBR = @PR_DD_NBR
						FOR XML PATH('BPMInfo'),Type)
					FOR XML PATH(''), ROOT('BPMData') )

				INSERT INTO dbo.BPM_REDSN_TXN (REDSGN_ID, REDSGN_NOTES_ID, BPM_DATA_TXT, REC_STUS_ID, CREAT_BY_USER_ID, CREAT_DT)
				SELECT	@RedesignID, 
						(SELECT REDSGN_NOTES_ID FROM dbo.REDSGN_NOTES WITH (NOLOCK) WHERE NOTES LIKE '%' + @PR_DD_NBR + '%'),
						@BPM_DATA_TXT, 261, 1, GETDATE()
			END
				
			SET @CTR = @CTR + 1
		END


		-- Update COWS Redesign from BPM View for Pending-NTE and Pending-SDE
		-- Resetting values
		SET @CTR = 1
		SET @CNT = 0
		SET @RedesignID = 0
		SET @sql = 'SELECT * FROM OPENQUERY(nrmbpm,''SELECT MNS_DD_NBR, CMNT_TXT, STUS_NME, DEV_NME, H6_ID, PR_DD_NBR FROM BPMF_OWNER.V_Bpmf_Cows_Mns_Rdsgn_Act_Evnt WHERE STUS_NME IN (''''Pending-SDE'''', ''''Pending-NTE'''') '')'

		DECLARE @UpdateCOWSRedesign TABLE (
			ID					INT IDENTITY(1,1)
			,MNS_DD_NBR			VARCHAR(20)
			,CMNT_TXT			VARCHAR(MAX)
			,STUS_NME			VARCHAR(100)
			,DEV_NME			VARCHAR(50)
			,H6_ID				VARCHAR(9)
			,PR_DD_NBR			VARCHAR(20))

		INSERT INTO @UpdateCOWSRedesign
		EXEC sp_executeSQL @sql
		--SELECT * FROM @UpdateCOWSRedesign
		SELECT @CNT = COUNT(1) FROM @UpdateCOWSRedesign

		WHILE (@CTR <= @CNT)
		BEGIN
			-- Set @RedesignID
			SELECT @RedesignID = REDSGN_ID FROM dbo.REDSGN WITH (NOLOCK) WHERE REDSGN_NBR = (SELECT MNS_DD_NBR FROM @UpdateCOWSRedesign WHERE ID = @CTR)

			-- Insert Redesign Devices Info
			--SELECT * FROM REDSGN_DEVICES_INFO WITH (NOLOCK) WHERE REDSGN_ID = @RedesignID
			INSERT INTO dbo.REDSGN_DEVICES_INFO (REDSGN_ID, SEQ_NBR, DEV_NME, H6_CUST_ID, NTE_CHRG_CD, REC_STUS_ID, CRETD_BY_CD, CRETD_DT)
			SELECT @RedesignID, 0, DEV_NME, H6_ID, 0, 1, 1, GETDATE()
			FROM @UpdateCOWSRedesign
			WHERE ID = @CTR AND ISNULL(DEV_NME,'') != '' AND DEV_NME NOT IN (SELECT DEV_NME FROM dbo.REDSGN_DEVICES_INFO WITH (NOLOCK) WHERE REDSGN_ID = @RedesignID)

			-- Insert Redesign Notes
			--SELECT * FROM REDSGN_NOTES WITH (NOLOCK) WHERE REDSGN_ID = @RedesignID
			INSERT INTO dbo.REDSGN_NOTES (REDSGN_ID,REDSGN_NTE_TYPE_ID,NOTES,CRETD_BY_CD,CRETD_DT)
			SELECT @RedesignID, 2, CMNT_TXT, 1, GETDATE()
			FROM @UpdateCOWSRedesign
			WHERE ID = @CTR AND ISNULL(CMNT_TXT,'') != '' AND CMNT_TXT NOT IN (SELECT NOTES FROM dbo.REDSGN_NOTES WITH (NOLOCK) WHERE REDSGN_ID = @RedesignID)

			-- Update COWS Redesign Status when BPM View Status is Pending-NTE
			--SELECT 'x' FROM @UpdateCOWSRedesign WHERE ID = @CTR AND STUS_NME = 'Pending-NTE'
			IF EXISTS (SELECT 'x' FROM @UpdateCOWSRedesign INNER JOIN dbo.REDSGN r WITH (NOLOCK) ON r.REDSGN_NBR = MNS_DD_NBR WHERE ID = @CTR AND STUS_NME = 'Pending-NTE' AND r.STUS_ID != 230)
			BEGIN
				UPDATE dbo.REDSGN SET STUS_ID = 230 WHERE REDSGN_ID = @RedesignID
				-- Insert Redesign Notes for Pending-NTE Status
				INSERT INTO dbo.REDSGN_NOTES (REDSGN_ID,REDSGN_NTE_TYPE_ID,NOTES,CRETD_BY_CD,CRETD_DT)
				SELECT @RedesignID, 1, 'Status changed to Pending-NTE based from BPM data.', 1, GETDATE()
			END

			SET @CTR = @CTR + 1
		END
	
	END TRY
	BEGIN CATCH
		EXEC dbo.insertErrorInfo
	END CATCH
END